/* global $, console, localStorage */    
function Prayerbook(languagesListEl, categoriesListEl, prayersListEl, prayerEl, itemTemplateEl, itemImageTemplateEl, languagesListEl2, langTemplateEl, btnStartEl, uiControl) {
        var self = this;
        this.NS = "http://www.creocode.com/catalog";
        this.languagesListEl = languagesListEl;
        this.categoriesListEl = categoriesListEl;
        this.prayersListEl = prayersListEl;
        this.prayerEl = prayerEl;
        this.itemTemplateEl = itemTemplateEl;
        this.itemImageTemplateEl = itemImageTemplateEl;
        this.languagesListEl2 = languagesListEl2;
        this.langTemplateEl = langTemplateEl;
        this.btnStartEl = btnStartEl;
        this.categories = ['Catechism', 'Requests'];
        this.lastCategories = [];
        this.prayers = [['Ten Commandments', 'Eight beatitudes'], ['Our Father', 'Hail Mary']];
        this.languages = [];

        this.showLanguages = function () {
            this.languagesListEl.children().remove();
            console.log("this.languages.length=" + this.languages.length);
            $.each(this.languages, function (number, language) {
                if(language.code === 'about') return;
                var langImgUrl = 'img/flag/' + language.code + '.png';
                var listItemEl = self.itemImageTemplateEl.clone();
                var langEl = self.langTemplateEl.clone();
                langEl.find("#lang_text").text(language.title);
                langEl.css("backgroundImage", "url('" + langImgUrl + "')");
                langEl.attr("data-lang", language.code).bind("click", function (evt) {
                    localStorage.setItem("selectedLanguage", number);
                    self.selectLanguageTap($(evt.target).attr("data-lang"));
                });
                self.languagesListEl2.append(langEl);
                listItemEl.find('a').text(language.title);
                listItemEl.find('img').attr('src', langImgUrl);
                
                listItemEl.bind('click', function (event) {
                    localStorage.setItem("selectedLanguage", number);
                });
                self.languagesListEl.append(listItemEl);
            });
        };

        this.selectLanguageTap = function (languageCode) {
            var language = this.findLanguageByCode(languageCode);
            $.getJSON("catalog/"+language.file, this.onGetCategory);
        };

        this.showCategoriesItems = function () {
            if (this.categories.length === 0) {
                this.showPrayers();
            } else {
                this.showCategories();
                $.ui.loadContent("categories", false, false, "none");
            }
        };

        this.findLanguageByCode = function (languageCode) {
            for (var index in this.languages) {
                if (this.languages[index].code === languageCode) {
                    return this.languages[index];
                }
            }
        };
                 
        this.showCategories = function () {
            this.btnStartEl.css("display", "none");
            this.categoriesListEl.children().remove();
            $.each(this.categories, function (number, category) {
                var listItemEl = self.itemTemplateEl.clone();
                listItemEl.find('a').text(category.title).attr("data-category", category.file);
                listItemEl.bind('click', self.onCategory);
                self.categoriesListEl.append(listItemEl);
            });
        };

        this.onCategory = function (evt) {
            var categoryFile = $(evt.target).attr("data-category");
            $.getJSON("catalog/"+categoryFile, self.onGetCategory);
        };
        
        this.onGetCategory = function(newCategory){
            self.lastCategories = self.categories;
            self.categories = newCategory.categories;
            self.items = newCategory.items;
            self.showCategoriesItems();    
        };

        this.showPrayers = function () {
            this.prayersListEl.children().remove();
            $.each(this.items, function (number, item) {
                var prayersListItemEl = self.itemTemplateEl.clone();
                prayersListItemEl.find('a').text(item.title);
                prayersListItemEl.bind('click', function (event) {
                    self.showPrayer(item);
                    $.ui.loadContent("prayer", false, false, "none");
                });
                self.prayersListEl.append(prayersListItemEl);
            });
            $.ui.loadContent("prayers", false, false, "none");
        };

        this.nl2br = function (textContent) {
            return textContent.replace(/(\r\n|\n\r|\r|\n)/g, "<br>");
        };

        this.showPrayer = function (item) {
            var buttonEdit = $('#button_edit');
            buttonEdit.attr("data-title", item.title);
            buttonEdit.attr("data-content", item.content);
            this.prayerEl.html(this.nl2br(item.content));
        };

        this.parseLanguages = function (xml) {
            if (this.languages.length === 0) {
                this.languages = this.toLanguagesList(xml);
            }
        };

        this.show = function () {
            this.showLanguages();
            var selectedLanguageSetting = localStorage.getItem("selectedLanguage");
            var selectedLanguage = -1;
            if (selectedLanguageSetting !== null) {
                selectedLanguage = parseInt(selectedLanguageSetting);
            }
            console.log("selectedLanguage:" + selectedLanguage);
            if (selectedLanguage !== -1) {
                this.categories = this.getCategories(this.languages[selectedLanguage]);
            } else {
                uiControl.languages();
            }

        };
        
        this.getCategories = function(category){
            $.getJSON("catalog/"+category.file, function (newCategory){
                self.categories = newCategory.categories;
                self.showCategories();
            });
        };
        
        this.getPrayerbook = function () {
            $.getJSON("catalog/catalog.json", function (data) {
                console.log(data);
                self.languages = data.categories;
                self.show();
            });
        };
        
        this.showAbout = function(){
            $.getJSON("catalog/category99.json", this.onGetCategory);
        };
    }